VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsWhatsApp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Autor: Leandro Ascierto
'Web: www.leandroascierto.com
'Date: 15/12/2019
'LastUpdate 17/03/19
'Requeriment: Microsfot Edge (html version) on windows 10 or later
'if you upgrade to the new Chromium-based Microsoft Edge version, follow these steps to be able to restore the html edge vercion
'https://www.askvg.com/tip-how-to-restore-old-legacy-microsoft-edge-browser-after-installing-new-edge-in-windows-10/

Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Private Declare Function FindWindowEx Lib "user32.dll" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long
Private Declare Function GetWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32.dll" () As Long
Private Declare Function GetTickCount Lib "kernel32.dll" () As Long
Private Declare Function RegisterWindowMessage Lib "user32" Alias "RegisterWindowMessageA" (ByVal lpString As String) As Long
Private Declare Function StringFromCLSID Lib "ole32.dll" (ByRef pCLSID As GUID, ByRef pOleStr As Long) As Long
Private Declare Function SendMessageTimeout Lib "user32.dll" Alias "SendMessageTimeoutA" (ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long, ByVal fuFlags As Long, ByVal uTimeout As Long, ByRef lpdwResult As Long) As Long
Private Declare Function FindWindow Lib "user32.dll" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function ShowWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Any) As Long
Private Declare Function IsWindow Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function IsIconic Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function OpenIcon Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Sub ObjectFromLresult Lib "OLEACC.dll" (ByVal lResult As Long, riid As GUID, ByVal wParam As Long, ByRef ppvObject As Any)

Private Type RECT
    Left    As Long
    Top     As Long
    Right   As Long
    Bottom  As Long
End Type

Private Type GUID
    Data1           As Long
    Data2           As Integer
    Data3           As Integer
    Data4(0 To 7)   As Byte
End Type

Private Const SMTO_ABORTIFHUNG          As Long = &H2
Private Const WM_GETTEXT                As Long = &HD
Private Const WM_GETTEXTLENGTH          As Long = &HE
Private Const GW_CHILD                  As Long = 5
Private Const GW_HWNDNEXT               As Long = 2

Public Event QrCodeChange(ByVal sImage As String)
Public Event QrCodeExpire()

Dim hTab As Long
Dim hIES As Long
Dim hAFW As Long
Dim Document As Object

Private m_ErrorNumber As Integer
Private m_Cancel As Boolean


'Incializa MS Edge en web.whatsapp.com (si es que no se encuentra ya abierto)
'Si necesita escanearse el codigo dispara el evento QrCodeChange()
'queda a la espara hasta que se escanee el codigo o se cancele.
Public Function Initialize(Optional HideMsEdge As Boolean) As Boolean
    Dim lCount As Long
    Dim TempDoc As Object
    Dim oDiv As Object
    
    m_Cancel = False

    If FindTabWhatsApp = False Then
        Shell "cmd.exe /c start shell:AppsFolder\Microsoft.MicrosoftEdge_8wekyb3d8bbwe!MicrosoftEdge: https://web.whatsapp.com", vbHide
        Waith 5000
        Do While FindTabWhatsApp = False
            If m_Cancel Then Exit Function
            lCount = lCount + 1
            Waith 1000
            If lCount = 60 Then
                m_ErrorNumber = 1
                Exit Function
            End If
        Loop
    End If

    lCount = 0
    Do While Document.readystate <> "complete"
        If IsWindow(hIES) = 0 Then m_ErrorNumber = 4: Debug.Print 1: Exit Function
        If m_Cancel Then Exit Function
        lCount = lCount + 1
        Waith 1000
        If lCount = 20 Then
            m_ErrorNumber = 2
            Exit Function
        End If
    Loop
    
    'Scan QRCode
    Dim sImgData As String
    Dim sLastImgData As String
    Dim m_Expire As Boolean
    Set oDiv = Document.GetElementsbyClassName("_2RT36")

    Do While oDiv.Length
        On Error Resume Next
        'sImgData = oDiv(0).GetElementsbytagName("img")(0).src
        sImgData = oDiv(0).getAttribute("data-ref")
      
        'Debug.Print sImgData
        If sImgData <> sLastImgData Then
            sLastImgData = sImgData
            m_Expire = False
            If m_Cancel Then Exit Function
            RaiseEvent QrCodeChange(oDiv(0).GetElementsbytagName("canvas")(0).toDataURL("image/png"))
        Else
            If oDiv(0).GetElementsbyClassName("JPE1j").Length Then
                If m_Expire = False Then
                    m_Expire = True
                    If m_Cancel Then Exit Function
                    RaiseEvent QrCodeExpire
                End If
            End If
        End If
        
        If IsWindow(hIES) = 0 Then m_ErrorNumber = 4: Debug.Print 2: Exit Function
        If m_Cancel Then Exit Function
        Waith 1000
    Loop

    'Loading
    lCount = 0
    Do While IsObject(Document.getElementById("startup"))
        lCount = lCount + 1
        If IsWindow(hIES) = 0 Then m_ErrorNumber = 4: Debug.Print 3: Exit Function
        If m_Cancel Then Exit Function
        Waith 1000
        If lCount = 50 Then
            m_ErrorNumber = 3
            Exit Function
        End If
    Loop
            
    If Not Document Is Nothing Then
        If FindAppFrameWindows Then
            If HideMsEdge Then ShowWindow hAFW, 0
            Call UseThisApp
            Initialize = True
        End If
    End If
    
End Function


'Retorna una coleccion de los ultimos mensages de un chat previamente abierto con openchat()
'El formmato de salida es el siguiente, la primer letra representa si es In o Out (entrada o salida)
'Luegos un Espacio, Hora y Fecha entre corchetes, Espacio Numero Telefonico, Espacio Mensage.
'O [15:14, 14/12/2019] +56 9 5900 9007: Chau
'I [23:00, 14/12/2019] +54 9 11 5250-2066: Hola
Public Function ReadMsgs() As Collection
    Dim Elements As Object
    Dim Element As Object
    Dim oSpan As Object
    Dim i As Long
    Dim cColl As New Collection
    Dim lCount As Long
    Dim oDiv As Object
    On Error Resume Next
    
    
    Do While Document.GetElementsbyClassName("_1_vLz").Length > 0
        Waith 200
        lCount = lCount + 1
        If lCount > 10 Then Exit Do
        If m_Cancel Then Exit Function
    Loop
    
    Set Elements = Document.GetElementsbyClassName("FTBzM")
 
    For i = 0 To Elements.Length - 1
        Set Element = Elements(i).GetElementsbyClassName("copyable-text")
        If Element.Length > 0 Then
            
            If InStr(Elements(i).classname, "message-out") Then
                
                Set oDiv = Element(0).GetElementsbyClassName("_F7Vk")
                If oDiv(oDiv.Length - 1).childElementCount Then
                    Set oSpan = oDiv(oDiv.Length - 1).firstChild
                Else
                    Set oSpan = oDiv(oDiv.Length - 1)
                End If
                cColl.Add "O " & Element(0).getAttribute("data-pre-plain-text") & GetPlaintText(oSpan)

            ElseIf InStr(Elements(i).classname, "message-in") Then
            
                Set oDiv = Element(0).GetElementsbyClassName("_F7Vk")
                If oDiv(oDiv.Length - 1).childElementCount Then
                    Set oSpan = oDiv(oDiv.Length - 1).firstChild
                Else
                    Set oSpan = oDiv(oDiv.Length - 1)
                End If
                cColl.Add "I " & Element(0).getAttribute("data-pre-plain-text") & GetPlaintText(oSpan)
            End If
        End If
    Next
    
    Set ReadMsgs = cColl
End Function

'Lama a que recargue el Codigo QR
Public Function RefreshQrCode() As Boolean
    If Document.GetElementsbyClassName("JPE1j").Length Then
        Document.GetElementsbyClassName("JPE1j")(0).Click
    End If
End Function

'Retora si se habrio web.whatsapp.com en otra pestaa o navegador.
Public Function IsOpenInOtherApp() As Boolean
    IsOpenInOtherApp = Document.GetElementsbyClassName("_2eK7W _3PQ7V").Length > 0
End Function

'si web.whatsapp.com se encuentra abierto en otro navegador fuerza a abrilo en este.
Public Function UseThisApp()
    If Document.GetElementsbyClassName("_2eK7W _3PQ7V").Length Then
        Document.GetElementsbyClassName("_2eK7W _3PQ7V")(0).Click
    End If
End Function

'Retorna un coleccin de la lista de contacto que tengan instalados WhatsApp
'Dentro de esta coleccin exiten 3 keys,"Contacts", "ImgProfile", "Phone"
'que corresponden a 3 colecciones con el Nombre del contacto, La imagen de perfil, y su Numero telefonico
'tambien se puede acceder por indice 1,2,3
Public Function GetContactList() As Collection
    On Error Resume Next
    Dim i As Long, j As Long
 
    Dim cContacts As New Collection
    Dim cImgProfile  As New Collection
    Dim cPhone  As New Collection
    
    Dim Elements As Object
    Dim oPanel As Object
    Dim lCount As Long
    Dim clicker As Object
    Dim oDiv As Object
    Dim t  As Long
    Dim sUrl As String
    Dim oParent As Object
    
    If IsWindow(hIES) = 0 Then m_ErrorNumber = 4: Exit Function
    
    If IsIconic(hAFW) Then OpenIcon hAFW
 
    Set oDiv = Document.GetElementsbyClassName("_1H6CJ _1rqO1")
        
    If oDiv.Length = 1 Then
        'Despliga Lista Nuevo Chat
        Set Elements = Document.GetElementsbyClassName("_3j8Pd")
        Set clicker = Document.createEvent("MouseEvents")
        Call clicker.initMouseEvent("mousedown", True, True, 0, 0, 0, 0, 0, 0, False, False, False, False, 0, Null)
        Call Elements(1).firstChild.dispatchEvent(clicker)
    End If
     
    Set oPanel = Document.GetElementsbyClassName("_1c8mz rK2ei")(0)
    
    oPanel.scrollTop = 0
    Waith 100

    For j = 0 To oPanel.scrollHeight Step 100
    lCount = 0
ReleerElementos:
        If IsWindow(hIES) = 0 Then m_ErrorNumber = 4: Exit Function
        If m_Cancel Then Exit Function
        
        If Err.Number Then
            Err.Clear
            lCount = lCount + 1
            
            If lCount = 10 Then
                m_ErrorNumber = 5: Exit Function
            End If
            Waith 10
        End If
    
        Set Elements = Document.GetElementsbyClassName("_19RFN _1ovWX _F7Vk")
        
        For i = 0 To Elements.Length - 1
            If Len(Elements(i).Title) Then
                If Err.Number Then GoTo ReleerElementos
                
                If AddItem(cContacts, Elements(i).Title) Then
                    
                    Set oParent = Elements(i).parentElement.parentElement.parentElement.parentElement

                    Err.Clear
                    If oParent.classname <> "_2UaNq" Then Set oParent = oParent.parentElement

                    sUrl = vbNullString
                    t = Timer + 2
                    
                    Do While t > Timer
                        If m_Cancel Then Exit Function
                        If oParent.GetElementsbyClassName("jZhyM _13Xdg _F7Vk").Length > 0 Then
                             sUrl = DecodeURL(oParent.GetElementsbyClassName("jZhyM _13Xdg _F7Vk")(0).src)
                             Exit Do
                        End If
                        DoEvents
                    Loop

                    cImgProfile.Add sUrl, Elements(i).Title
                    cPhone.Add GetPhoneFromUrlImg(sUrl), Elements(i).Title

                End If
            End If
        Next

        oPanel.scrollTop = j
        Waith 10
    Next
    
    Set GetContactList = New Collection
    GetContactList.Add cContacts, "Contacts"
    GetContactList.Add cImgProfile, "ImgProfile"
    GetContactList.Add cPhone, "Phone"
  
End Function

'Retorna un coleccin de la lista de lso chats que se encuentren en uso
'Dentro de esta coleccin exiten 4 keys,"Contacts", "ImgProfile", "Phone", "UnreadMsg"
'que corresponden a 3 colecciones con el Nombre del contacto, La imagen de perfil, su Numero telefonico, Numero de mensages sin leer por cada chat
'tambien se puede acceder por indice 1,2,3,4
Public Function GetChatList(Optional MaxNroRead As Integer) As Collection
    On Error Resume Next
    Dim i As Long, j As Long
    Dim cContacts As New Collection
    Dim cUnreadMsg  As New Collection
    Dim cImgProfile  As New Collection
    Dim cPhone  As New Collection
    Dim Elements As Object
    Dim oPanel As Object
    Dim lCount As Long
    Dim oSpan As Object
    Dim t  As Long
    Dim sUrl As String
    Dim oParent As Object
    
    If IsWindow(hIES) = 0 Then m_ErrorNumber = 4: Exit Function
    If IsIconic(hAFW) Then OpenIcon hAFW
    
    Set oPanel = Document.getElementById("pane-side")
    oPanel.scrollTop = 0
    Waith 100
    
    For j = 0 To oPanel.scrollHeight Step 100
    lCount = 0
ReleerElementos:
        If m_Cancel Then Exit Function
        If IsWindow(hIES) = 0 Then m_ErrorNumber = 4: Exit Function
        If Err.Number Then
            Err.Clear
            lCount = lCount + 1
            If lCount = 10 Then
                m_ErrorNumber = 6: Exit Function
            End If
            Waith 10
        End If
        
        Set Elements = Document.GetElementsbyClassName("_19RFN _1ovWX _F7Vk")
        
        For i = 0 To Elements.Length - 1
            If Len(Elements(i).Title) Then
                If Err.Number Then GoTo ReleerElementos
                
                If AddItem(cContacts, Elements(i).Title) Then
                    Set oParent = Elements(i).parentElement.parentElement.parentElement.parentElement
                     
                    Set oSpan = oParent.GetElementsbyClassName("P6z4j")
                  
                    If oSpan.Length Then
                        cUnreadMsg.Add oSpan(0).innertext, Elements(i).Title
                    Else
                        cUnreadMsg.Add 0, Elements(i).Title
                    End If
                    
                    Err.Clear
                    If oParent.classname <> "_2UaNq" Then Set oParent = oParent.parentElement


                    sUrl = vbNullString
                    t = Timer + 2
                    
                    Do While t > Timer
                        If m_Cancel Then Exit Function
                        If oParent.GetElementsbyClassName("jZhyM _13Xdg _F7Vk").Length > 0 Then
                             sUrl = DecodeURL(oParent.GetElementsbyClassName("jZhyM _13Xdg _F7Vk")(0).src)
                             
                             Exit Do
                        End If
                        DoEvents
                    Loop
                
                    cImgProfile.Add sUrl, Elements(i).Title
                    cPhone.Add GetPhoneFromUrlImg(sUrl), Elements(i).Title
                    If MaxNroRead > 0 Then If MaxNroRead <= cContacts.Count Then Exit For

                End If
            End If
        Next
        If MaxNroRead > 0 Then If MaxNroRead <= cContacts.Count Then Exit For
        oPanel.scrollTop = j
        Waith 10
    Next
       
    Set GetChatList = New Collection
    GetChatList.Add cContacts, "Contacts"
    GetChatList.Add cImgProfile, "ImgProfile"
    GetChatList.Add cPhone, "Phone"
    GetChatList.Add cUnreadMsg, "UnreadMsg"
End Function

'Envia un msg a un contacto existente, si retorna true, la operacion tuvo exito
'si retorna False puede consultar al LastErrorNumber o LastErrorDescription
Public Function SendMsg(ByVal Contact As String, ByVal sMsg As String) As Boolean
    Dim lCount As Long
    Dim Element As Object
    Dim InputEvent As Object
    If Len(sMsg) = 0 Then m_ErrorNumber = 7: Exit Function
    If IsWindow(hIES) = 0 Then m_ErrorNumber = 4: Exit Function
    If Document Is Nothing Then Exit Function
    
    Set Element = Document.GetElementsbyClassName("_1lpto")
    
    If Element.Length > 0 Then
        If Element(0).innertext <> Contact Then
            If OpenChat(Contact, True) = False Then
                m_ErrorNumber = 6
                Exit Function
            End If
        End If
    Else
        If OpenChat(Contact, True) = False Then
            m_ErrorNumber = 6
            Exit Function
        End If
    End If
    
    Set Element = Document.GetElementsbyClassName("_3u328")(1)
    Element.innertext = sMsg
    Set InputEvent = Document.createEvent("Event")
    Call InputEvent.initEvent("input", True, True)
    Element.dispatchEvent InputEvent

    Document.GetElementsbyClassName("_3M-N-")(0).Click
    
    Set Element = Document.GetElementsbyClassName("FTBzM message-out")
    lCount = Element.Length
    If lCount > 0 Then
        SendMsg = CBool(sMsg = Element(lCount - 1).GetElementsbyClassName("_F7Vk")(0).innertext)
    End If
End Function

'Abre un chat con un contacto existente, el segundo parametro "NewChat" es por si no se tienen un chat activo como dicho contacto
'ponerlo como True asegura el exito de la operacion, pero es mas lento.
'si se tienen dicho control aconsejo NewChat =False, de lo contrario True.
'si la operacion falla retorna False
Public Function OpenChat(ByVal sContact As String, NewChat As Boolean) As Boolean
    On Error Resume Next
    Dim i As Long, j As Long
    Dim cColl As New Collection
    Dim Elements As Object
    Dim oPanel As Object
    Dim clicker As Object
    Dim lCount As Long
    Dim oDiv As Object
    Dim lStart As Long
    Dim lEnd As Long
    Err.Clear
    
    
    If Document.GetElementsbyClassName("_1lpto").Length > 0 Then
        If Document.GetElementsbyClassName("_1lpto")(0).innertext = sContact Then
            OpenChat = True
            Exit Function
        End If
    End If
    
    
    If NewChat Then
       Set oDiv = Document.GetElementsbyClassName("_1H6CJ _1rqO1")
           
       If oDiv.Length = 1 Then
           'Despliga Lista Nuevo Chat
           Set Elements = Document.GetElementsbyClassName("_3j8Pd")
           Set clicker = Document.createEvent("MouseEvents")
           Call clicker.initMouseEvent("mousedown", True, True, 0, 0, 0, 0, 0, 0, False, False, False, False, 0, Null)
           Call Elements(1).firstChild.dispatchEvent(clicker)
       End If
       
    
       Set oPanel = Document.GetElementsbyClassName("_1c8mz rK2ei")(0)
    
    Else
        Set oPanel = Document.getElementById("pane-side")
    End If
    
    If Asc(Left$(sContact, 1)) < 77 Then
        lStart = 0
        lEnd = oPanel.scrollHeight
    Else
        lStart = oPanel.scrollHeight
        lEnd = 0
    End If
    
    oPanel.scrollTop = lStart

    Waith 10
    
    For j = lStart To lEnd Step IIf(lEnd < lStart, -100, 100)
    
ReleerElementos:
        
        If Err.Number Then
            Err.Clear
            lCount = lCount + 1
            If lCount = 10 Then
                Exit Function
            End If
            Waith 10
        End If
        
        Set Elements = Document.GetElementsbyClassName("_19RFN _1ovWX _F7Vk")
        
        For i = 0 To Elements.Length - 1
            If m_Cancel Then Exit Function
            If Len(Elements(i).Title) Then
                If Err.Number Then GoTo ReleerElementos
                
                If sContact = Elements(i).Title Then
                    If NewChat Then
                        'Call elements(i).scrollintoview(True)
                        Call Elements(i).Click
                        
                    Else
                        Set clicker = Document.createEvent("MouseEvents")
                        Call clicker.initMouseEvent("mousedown", True, True, 0, 0, 0, 0, 0, 0, False, False, False, False, 0, Null)
                        Call Elements(i).dispatchEvent(clicker)
                    End If
              
                    Waith 1000

                    Set oDiv = Document.GetElementsbyClassName("_1lpto")
                    If oDiv.Length > 0 Then
                        If oDiv(0).GetElementsbyClassName("_19RFN")(0).getAttribute("Title") = sContact Then
                            OpenChat = True
                            Exit Function
                        Else
                            Exit Function
                        End If
                    
                    Else
                        Exit Function
                    End If
                End If
               
            End If
            
        Next
        oPanel.scrollTop = j
        Waith 10
   
    Next
    
    m_ErrorNumber = 6
End Function

'Retorna la imagen de perfil del contacto indicado o chat abierto.
Public Function GetImgProfile(ByVal sContact As String) As String
    On Error Resume Next
    Dim oHeader As Object
    Dim sUrl As String
    If OpenChat(sContact, False) Then
        Set oHeader = Document.GetElementsbyClassName("_3fs0K")(0)
        sUrl = oHeader.GetElementsbyClassName("jZhyM _13Xdg _F7Vk")(0).src
        GetImgProfile = DecodeURL(sUrl)
    End If
    If Err.Number Then Debug.Print "Error: GetImgProfile"
End Function

'Retorna el Nro telefonico del contacto indicado o chat abierto.
Public Function GetContactNumber(ByVal sContact As String) As String
    On Error Resume Next
    If OpenChat(sContact, False) Then
        Document.GetElementsbyClassName("_1lpto")(0).Click
        GetContactNumber = Document.GetElementsbyClassName("_6xQdq")(3).innertext
    End If
    If Err.Number Then Debug.Print "Error: GetContactNumber"
End Function

'Retorna el alias de un numero no agendado (~Juan Perez)
Public Function GetAliasForUnregisterNumber(ByVal sNumber As String) As String
    On Error Resume Next
    If OpenChat(sNumber, False) Then
        Document.GetElementsbyClassName("_1lpto")(0).Click
        If Document.GetElementsbyClassName("_2he9- _F7Vk").Length Then
            GetAliasForUnregisterNumber = Document.GetElementsbyClassName("_2he9- _F7Vk")(0).innertext
        End If
    End If
    If Err.Number Then Debug.Print "Error: GetAliasForUnregisterNumber"
End Function


Private Function CerrarGaleria()
    If Document.GetElementsbyClassName("_1HjMu").Length Then
        Document.GetElementsbyClassName("_1HjMu")(0).Click
         Waith 100
    End If
End Function

Public Function GetMyImagenProfile() As String
    On Error Resume Next
    Dim sUrl As String
    
    CerrarGaleria
    
    Document.GetElementsbyClassName("jZhyM _13Xdg _F7Vk")(0).Click
    sUrl = Document.GetElementsbyClassName("_F7Vk")(0).src
    GetMyImagenProfile = DecodeURL(sUrl)
    If Document.GetElementsbyClassName("qfKkX").Length Then
        Document.GetElementsbyClassName("qfKkX")(0).Click
    End If
    If Err.Number Then Debug.Print "Error: GetMyImagenProfile"
End Function

Public Function GetMyNameProfile() As String
    On Error Resume Next
    CerrarGaleria
    Document.GetElementsbyClassName("jZhyM _13Xdg _F7Vk")(0).Click
    GetMyNameProfile = Document.GetElementsbyClassName("_3u328 copyable-text selectable-text")(0).innertext
    Document.GetElementsbyClassName("qfKkX")(0).Click
    
    If Err.Number Then Debug.Print "Error: GetMyNameProfile"
End Function

Public Function IsThePhoneOffline() As Boolean
    Dim oElements As Object
    
    Set oElements = Document.GetElementsbyClassName("_25f0v")
    If oElements.Length > 0 Then
        Set oElements = oElements(0).GetElementsbytagName("span")
        If oElements.Length > 0 Then
            IsThePhoneOffline = CBool(oElements(0).getAttribute("data-icon") = "alert-phone")
        End If
    End If
End Function

Public Function IsThePhoneBatteryLow() As Boolean
    Dim oElements As Object
    
    Set oElements = Document.GetElementsbyClassName("_25f0v")
    If oElements.Length > 0 Then
        Set oElements = oElements(0).GetElementsbytagName("span")
        If oElements.Length > 0 Then
            IsThePhoneBatteryLow = CBool(oElements(0).getAttribute("data-icon") = "alert-battery")
        End If
    End If
End Function


Public Function IsTheComputerOffLine() As Boolean
    Dim oElements As Object
    
    Set oElements = Document.GetElementsbyClassName("_25f0v")
    If oElements.Length > 0 Then
        Set oElements = oElements(0).GetElementsbytagName("span")
        If oElements.Length > 0 Then
            IsTheComputerOffLine = CBool(oElements(0).getAttribute("data-icon") = "alert-computer")
        End If
    End If
End Function

Private Function FindAppFrameWindows() As Boolean
    Dim hwnd As Long
    Dim sDocTitle As String, sWinTitle As String
    sDocTitle = Document.Title
    hwnd = GetWindow(GetDesktopWindow, GW_CHILD)
    Do While hwnd <> 0&
        If ClassNameOf(hwnd) = "ApplicationFrameWindow" Then
            sWinTitle = GetWindowText(hwnd)
            If Left(sWinTitle, Len(sDocTitle)) = sDocTitle Then
                hAFW = hwnd
                FindAppFrameWindows = True
                Exit Function
            End If
        End If
        hwnd = GetWindow(hwnd, GW_HWNDNEXT)
    Loop
End Function

'Cancela la operacion que se encuentre en ejecucion
Public Sub Cancel()
    m_Cancel = True
End Sub

'Borra el error
Public Function ErrorClear()
    m_ErrorNumber = 0
End Function

'Retorna el ultimo Nro de Error
Public Function LastErrorNumber() As Integer
    LastErrorNumber = m_ErrorNumber
End Function

'Retorna la ultima Descripcion de Error
Public Function LastErrorDescription() As String
    Dim S As String
    Select Case m_ErrorNumber
        Case 1: S = "Tiempo de espera agotado, MS Edge no cargo la pestaa"
        Case 2: S = "Tiempo de espera agotado, no se cargo el documento"
        Case 3: S = "Tiempo de espera agotado, web.whatsapp.com no cargo correctamente"
        Case 4: S = "El navegador MS Edge fue cerrado o la pestaa de web.whatsapp.com"
        Case 5: S = "Error al recuperar lista de contactos"
        Case 5: S = "Error al recuperar lista de chats"
        Case 6: S = "No se encontro el contacto"
        Case 7: S = "Mensage basio"
    End Select
    LastErrorDescription = S
End Function

Private Function FindTabWhatsApp() As Boolean
    On Error Resume Next
    Dim hwnd As Long
    Dim TempDoc As Object
    hwnd = GetWindow(GetDesktopWindow, GW_CHILD)
    Do While hwnd <> 0&
        If ClassNameOf(hwnd) = "TabWindowClass" Then
              hIES = FindWindowEx(hwnd, ByVal 0&, "Internet Explorer_Server", vbNullString)
              If hIES Then
                  Set TempDoc = GetHTMLDocumentFromWindow(hIES)
                  If Not TempDoc Is Nothing Then
                    'Waith 100
                    If TempDoc.URL = "https://web.whatsapp.com/" Then
                        Set Document = TempDoc
                        FindTabWhatsApp = True
                        Exit Function
                    End If
                  End If
              End If
        End If
        hwnd = GetWindow(hwnd, GW_HWNDNEXT)
    Loop
    If Err.Number Then Debug.Print "Error en FindTabWhatsApp"
End Function

Private Function Waith(ByVal MiliSeconds As Integer)
    Dim TimeOut As Long
    TimeOut = GetTickCount + MiliSeconds
    Do While TimeOut > GetTickCount
        DoEvents
        If m_Cancel Then Exit Function
    Loop
End Function

Private Function AddItem(cColl As Collection, Contact As String) As Boolean
    Dim i As Long
    For i = 1 To cColl.Count
        If cColl.Item(i) = Contact Then Exit Function
    Next
    
    cColl.Add Contact
    AddItem = True
End Function

Private Sub Class_Terminate()
    m_Cancel = True
End Sub

Private Function GetWindowText(ByVal hwnd As Long) As String
    Dim TextLen As Long
    TextLen = SendMessage(hwnd, WM_GETTEXTLENGTH, 0&, 0&)
    GetWindowText = String(TextLen, Chr$(0))
    SendMessage hwnd, WM_GETTEXT, TextLen + 1, GetWindowText
End Function
Private Function ClassNameOf(ByVal hwnd As Long) As String
   Dim sClassName As String, Ret As Long
   sClassName = Space(256)
   Ret = GetClassName(hwnd, sClassName, 256)
   If Ret Then ClassNameOf = Left$(sClassName, Ret)
End Function

Private Function GetHTMLDocumentFromWindow(hwnd As Long) As Object
    Dim IID_IHTMLDocument As GUID
    Dim lRes As Long
    Dim nMsg As Long
    
    StringFromCLSID IID_IHTMLDocument, StrPtr("626FC520-A41E-11CF-A731-00A0C9082637")
    nMsg = RegisterWindowMessage("WM_HTML_GETOBJECT")
    
    If Not (nMsg = 0) Then
        Call SendMessageTimeout(hwnd, nMsg, 0, 0, SMTO_ABORTIFHUNG, 1000, lRes)
        If Not (lRes = 0) Then
          Call ObjectFromLresult(lRes, IID_IHTMLDocument, 0, GetHTMLDocumentFromWindow)
        End If
    End If
 
End Function

Private Function GetPlaintText(Element As Object) As String
    Dim i As Long, S As String
    Dim oImg As Object

    If Len(Element.innerhtml) = 0 Then
        Set oImg = Element.parentElement.GetElementsbytagName("Img")
        S = Element.parentElement.innerhtml
    Else
        Set oImg = Element.GetElementsbytagName("Img")
        S = Element.innerhtml
    End If
    
    For i = 0 To oImg.Length - 1
        If Not IsNull(oImg(i).getAttribute("data-plain-text")) Then
            S = Replace(S, oImg(i).outerhtml, oImg(i).getAttribute("data-plain-text"))
        Else
            S = Replace(S, oImg(i).outerhtml, vbNullString)
        End If
    Next
    
    GetPlaintText = S
End Function

Private Function GetPhoneFromUrlImg(ByVal sUrl As String) As String
    Dim lPos1 As Long, lPos2 As Long
    lPos1 = InStr(sUrl, "&u=")
    If lPos1 = 0 Then Exit Function
    lPos2 = InStr(lPos1, sUrl, "@")
    If lPos2 Then
        GetPhoneFromUrlImg = Mid$(sUrl, lPos1 + 3, lPos2 - lPos1 - 3)
        lPos1 = InStr(GetPhoneFromUrlImg, "-")
        If lPos1 Then
            GetPhoneFromUrlImg = Left(GetPhoneFromUrlImg, lPos1 - 1)
        End If
    End If
End Function

Private Function DecodeURL(ByVal sUrl As String) As String
    Dim lPos        As Long
    Dim bvData()    As Byte
    Dim i           As Long
    Dim sChar       As String * 1
    
    lPos = InStr(sUrl, "pp?e=")
    If lPos Then
        bvData = Mid(sUrl, lPos + 5)
    Else
        DecodeURL = sUrl
        Exit Function
    End If

    For i = 0 To UBound(bvData) Step 2
        sChar = Chr$(bvData(i))
        If sChar = "%" Then
            DecodeURL = DecodeURL & Chr$(Val("&h" & Chr$(bvData(i + 2)) & Chr$(bvData(i + 4))))
            i = i + 4
        Else
        DecodeURL = DecodeURL & sChar
        End If
    Next

End Function




